include win64a.inc
includelib msvcrt.lib
include msvcrt.inc
STD_OUTPUT_HANDLE equ -11
STD_INPUT_HANDLE equ -10
TRUE	equ 1
FALSE equ 0
BLACK	equ 0 
BLUE	equ 1
GREEN	equ 2
CYAN	equ 3
RED	equ 4
PURPLE	equ 5
YELLOW	equ 6
SYSTEM	equ 7
GREY	equ 8
BRIGHTBLUE equ 9
BRIGHTGREEN equ 10
BRIGHTCYAN equ 11
BRIGHTRED equ 12 
BRIGHTPURPLE equ 13
BRIGHTYELLOW equ 14
WHITE	equ 15
MAXSCREENX = 80
MAXSCREENY = 25
buffersize = 200
SMALL_RECT STRUCT
   Left      WORD      ?
   Top       WORD      ?
   Right     WORD      ?
   Bottom    WORD      ?
SMALL_RECT ENDS

COORD STRUCT
	X  WORD ?
	Y  WORD ?
COORD ends

CONSOLE_FONT_INFOEX struct
	cbSize dword 0
	nFont dword 0
	dwFontSize COORD <>
	FontFamily dword 0
	FontWeight dword 0
	FaceName word 32 dup (0)
CONSOLE_FONT_INFOEX ends


.data

STR1 dw 266Ah,266Bh,20h,41Fh,440h,43Eh,449h,430h,439h,20h,263Ah,0Dh,0Ah
STR2 db 'Console',0
STR3 dw 423h,43Ah,430h,437h,430h,43Dh,20h,43Ah,43Eh,434h,20h,443h,441h,442h,440h,\
43Eh,439h,441h,442h,432h,430h,2Ch,20h,43Dh,435h,20h,438h,441h,43Fh,43Eh,43Bh,44Ch;'  ன⢠,  ᯮ㥬  ⥬'
fontname1: du <Lucida Console>
fontname2: du <Consolas>
SetCurrentConsoleFontEx dq ?
LibName db 'kernel32.dll',0
FunctionName db 'SetCurrentConsoleFontEx',0
.code

WinMain Proc

local hOut:qword
;local fontuni [64]:byte
local charsWritten : dword
local ConsoleWindow:SMALL_RECT
local myFont : CONSOLE_FONT_INFOEX
	
	mov ecx,offset LibName
	invoke LoadLibrary      
	mov edx,offset FunctionName
	invoke GetProcAddress,eax
        mov SetCurrentConsoleFontEx,rax

	invoke FreeConsole;release the existing console
	invoke AllocConsole;form the console

	invoke GetStdHandle, STD_OUTPUT_HANDLE
        mov hOut,rax

	invoke GetLargestConsoleWindowSize, hOut

	mov	ConsoleWindow.Left,0
	mov	ConsoleWindow.Top,0

	sub	ax, MAXSCREENX
	sbb	edx, edx
	and	ax, dx
	add	ax, MAXSCREENX-1
	mov	ConsoleWindow.Right,ax

	shr	eax, 16
	sub	eax, MAXSCREENY
	sbb	edx, edx
	and	eax, edx
	add	eax, MAXSCREENY-1
	mov	ConsoleWindow.Bottom,ax

	invoke SetConsoleWindowInfo, hOut, TRUE, &ConsoleWindow
	invoke SetConsoleScreenBufferSize, hOut, MAXSCREENY*10000h+MAXSCREENX
	
	invoke SetConsoleTitle,&STR2
	invoke SetConsoleCursorPosition, hOut, 0A0000h
	invoke SetConsoleTextAttribute, hOut, BRIGHTGREEN
	
	mov myFont.cbSize, sizeof CONSOLE_FONT_INFOEX
	mov myFont.nFont, 0
	mov myFont.dwFontSize.X, 0h
	mov myFont.dwFontSize.Y, 24
	mov myFont.FontFamily, 0
	mov myFont.FontWeight, 400
	invoke wcscpy,&myFont.FaceName, &fontname1
	invoke SetCurrentConsoleFontEx, hOut, FALSE, &myFont
	.if eax==0
		ret
	.endif
	invoke WriteConsoleW, hOut, &STR1, lengthof STR1, &charsWritten, 0

	mov myFont.cbSize, sizeof CONSOLE_FONT_INFOEX
	mov myFont.nFont, 0
	mov myFont.dwFontSize.X, 0h
	mov myFont.dwFontSize.Y, 24
	mov myFont.FontFamily, 0
	mov myFont.FontWeight, 400
	invoke wcscpy, &myFont.FaceName, &fontname2
	invoke SetCurrentConsoleFontEx, hOut, FALSE, &myFont
	.if eax==0
		ret
	.endif
	invoke WriteConsoleW,hOut,&STR3,lengthof STR3,&charsWritten,0
	
	invoke getchar
	invoke FreeConsole
	invoke ExitProcess, 0
WinMain endp
end